#include "x86.h"
#include "console_io.h"


unsigned char __NOINLINE getc() {
  while ((inb(SERIAL_PORT + 5) & 1) == 0);
  return inb(SERIAL_PORT);
}


void __NOINLINE putc(unsigned char c) {
  while ((inb(SERIAL_PORT + 5) & 0x20) == 0);
  outb(SERIAL_PORT, c);
}


void init_console() {
  outb(SERIAL_PORT + 1, 0x00);  /* Disable irq */
  outb(SERIAL_PORT + 3, 0x80);  /* baud rate divisor */
  outb(SERIAL_PORT + 0, 0x01);  /* divisor = 1 (lo byte) 115200 baud */
  outb(SERIAL_PORT + 1, 0x00);  /*             (hi byte */
  outb(SERIAL_PORT + 3, 0x03);  /* 8 bits, no parity, 1 stop bit */
  outb(SERIAL_PORT + 2, 0xC7);  /* Enable FIFO, clear, 14-byte threshold */
  outb(SERIAL_PORT + 4, 0x0B);  /* IRQs enabled, RTS/DSR set */
  xdev_out(putc);
  xdev_in(getc);
}
